Woopsi 1.0 GUI Framework for Nintendo DS Homebrew

- Main Page
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Protected Attributes

# WoopsiUI::BitmapBase Class Reference

`#include <bitmapbase.h>`

Inheritance diagram for WoopsiUI::BitmapBase:

List of all members.

## Public Member Functions
virtual | ~BitmapBase ()
virtual const u16 * | getData () const =0
virtual const u16 * | getData (s16 x, s16 y) const =0
virtual const u16 | getPixel (s16 x, s16 y) const =0
virtual void | copy (s16 x, s16 y, u32 size, u16 *dest) const =0
const u16 | getWidth () const
const u16 | getHeight () const
## Protected Attributes
u16 | _width
u16 | _height

## Detailed Description

Abstract class defining the basic properties of a bitmap. Since the DS has 16-bit displays (1 alpha bit and 5 bits each for RGB), all bitmaps must expose their data in the same format.

However, since this class does not define how the data is stored, it is possible for a subclass to store the bitmap data in whatever format necessary (1, 2, 4, 8, 24 or 32-bits, or any format at all) as long as it translates back to the DS' native 16-bit format when accessed externally.

## Constructor & Destructor Documentation

virtual WoopsiUI::BitmapBase::~BitmapBase | ( |  | ) | `[inline, virtual]`

Destructor.

## Member Function Documentation

virtual void WoopsiUI::BitmapBase::copy | ( | s16 | x,
|  | s16 | y,
|  | u32 | size,
|  | u16 * | dest
| ) |  | const`[pure virtual]`

Copies data from the supplied co-ordinates sequentially into dest. If the amount to be copied exceeds the available width of the bitmap, copying will wrap around from the right-hand edge of the bitmap to the left-hand edge. The dest parameter must point to an area of memory large enough to contain the copied data.

Parameters:

  x | The x co-ordinate to copy from.
  y | The y co-ordinate to copy from.
  size | The number of pixels to copy.
  dest | Pointer to the memory that will be copied into.

Implemented in WoopsiUI::Bitmap, WoopsiUI::BitmapWrapper, and WoopsiUI::FrameBuffer.

virtual const u16* WoopsiUI::BitmapBase::getData | ( |  | ) | const`[pure virtual]`

Get a pointer to the internal bitmap data.

Returns:
  Pointer to the internal bitmap data.

Implemented in WoopsiUI::Bitmap, WoopsiUI::BitmapWrapper, and WoopsiUI::FrameBuffer.

virtual const u16* WoopsiUI::BitmapBase::getData | ( | s16 | x,
|  | s16 | y
| ) |  | const`[pure virtual]`

Get a pointer to the internal bitmap data at the specified co-ordinates.

Parameters:

  x | The x co-ord of the data.
  y | The y co-ord of the data.

Returns:
  Pointer to the internal bitmap data.

Implemented in WoopsiUI::Bitmap, WoopsiUI::BitmapWrapper, and WoopsiUI::FrameBuffer.

const u16 WoopsiUI::BitmapBase::getHeight | ( |  | ) | const`[inline]`

Get the bitmap's height.

Returns:
  The bitmap's height.

virtual const u16 WoopsiUI::BitmapBase::getPixel | ( | s16 | x,
|  | s16 | y
| ) |  | const`[pure virtual]`

Get the colour of the pixel at the specified co-ordinates

Parameters:

  x | The x co-ordinate of the pixel.
  y | The y co-ordinate of the pixel.

Returns:
  The colour of the pixel.

Implemented in WoopsiUI::Bitmap, WoopsiUI::BitmapWrapper, and WoopsiUI::FrameBuffer.

const u16 WoopsiUI::BitmapBase::getWidth | ( |  | ) | const`[inline]`

Get the bitmap's width.

Returns:
  The bitmap's width.

## Member Data Documentation

u16 WoopsiUI::BitmapBase::_height`[protected]`

Height of the bitmap

u16 WoopsiUI::BitmapBase::_width`[protected]`

Width of the bitmap

The documentation for this class was generated from the following file:

- bitmapbase.h